## Test accuruacy and command line
0.9871: 
python main.py --net mpomlp --cuda 2 --dims "2,2,7,7,2,2;9,9,9,9,9,9;1,1,1,5,2,1" --lr 0.01 --chi 10 --lr_decay 0.1 --lr_decay_epochs 10 --l2 1.0e-7

0.9866:
main.py --net mpomlp --cuda 2 --dims "2,2,7,7,2,2;4,4,4,4,4,4;1,1,1,5,2,1" --lr 0.01 --chi 10 --lr_decay 0.8 --lr_decay_epochs 5 --l2 1.0e-7 --bn --log log/mpomlp_l2_4,4,4,4,4,4_bn_1.txt

0.9887:
python main.py --net mpomlp --cuda 3 --dims "2,2,7,7,2,2;5,5,5,5,5,5;1,1,1,5,2,1" --lr 0.01 --chi 20 --lr_decay 0.9 --lr_decay_epochs 5 --l2 1.0e-7 --bn --valid 200


0.9890:
python main.py --net mpomlp --cuda 2 --dims "2,2,7,7,2,2;5,5,5,5,5,5;1,1,1,5,2,1" --lr 0.01 --chi 25 --lr_decay 0.9 --lr_decay_epochs 10 --l2 1.0e-7 --bn --valid 200 --aug --aug2 —ingpu


working:
python main.py --net conv --cuda 0 --lr 0.001 --lr_decay 0.9 --lr_decay_epochs 5 --l2 1.0e-7 --net conv2 --channels 16,16 --convmpo --dims "4,4,9,4;4,4,4,4;1,5,2,1"


0.991 33232 parameters
python main.py --net conv --cuda --lr_decay_epochs 50 --l2 1.0e-7 --net conv2 --channels 16,16 --convmpo --dims "4,4,9,4;5,5,5,5;1,5,2,1" --chi 16

0.9918 15764 parameters
python main.py --net conv --cuda 0 --lr 0.001 --lr_decay 0.9 --lr_decay_epochs 50 --l2 1.0e-7 --net conv2 --channels 16,16 --D 256 --convmpo --dims "4,4,9,4;4,4,4,4;1,5,2,1" --chi 10 --bn

0.9916 13248+6996 = 20244 Parameters
python main.py --net conv --cuda 0 --lr 0.001 --lr_decay 0.9 --lr_decay_epochs 50 --l2 1.0e-7 --net conv2 --channels 16,32 --D 256 --convmpo --dims "4,8,9,4;4,4,4,4;1,5,2,1" --chi 8 --bn
As a comparison,
python main.py --net conv --cuda 0 --lr 0.001 --lr_decay 0.9 --lr_decay_epochs 50 --l2 1.0e-7 --net conv2 --channels 16,32 --D 256 --dims "4,8,9,4;4,4,4,4;1,5,2,1" --chi 8 —bn
310986 parameters


0.9909
python main.py --net conv --cuda 2 --lr 0.001 --lr_decay 0.9 --lr_decay_epochs 50 --l2 1.0e-7 --net conv2 --channels 16,16 --convmpo --dims "4,4,9,4;5,5,5,5;1,5,2,1" --chi 8
13636 parameters

python main.py --net conv --cuda 0 --lr 0.001 --lr_decay 0.9 --lr_decay_epochs 50 --l2 1.0e-7 --net conv2 --channels 16,32 --convmpo --dims "3,8,8,6;5,5,5,5;1,5,2,1" --chi 9 --kernel_size 3,3 --paddings 0,1
14610 parameters
Baseline:
python main.py --net conv --cuda 2 --lr 0.001 --lr_decay 0.9 --lr_decay_epochs 50 --l2 1.0e-7 --net conv2 --channels 16,32 --dims "3,8,8,6;5,5,5,5;1,5,2,1" --chi 8 --kernel_size 3,3 --paddings 0,1 --D 625
731685 parameters

python main.py --net conv --cuda 2 --lr 0.001 --lr_decay 0.9 --lr_decay_epochs 50 --l2 1.0e-7 --net conv2 --channels 16,64 --dims "6,8,8,6;5,5,5,5;1,5,2,1" --chi 8 --kernel_size 3,3 --paddings 0,1 —convmpo
0.9903 17360 parameters
Base line
python main.py --net conv --cuda 2 --lr 0.001 --lr_decay 0.9 --lr_decay_epochs 50 --l2 1.0e-7 --net conv2 --channels 16,64 --dims "6,8,8,6;5,5,5,5;1,5,2,1" --chi 8 --kernel_size 3,3 --paddings 0,1 —D 625
1456325 parameters  83


> 0.9910
python main.py --net conv --cuda 2 --lr 0.001 --lr_decay 0.9 --lr_decay_epochs 50 --l2 1.0e-7 --net conv2 --channels 16,64 --dims "6,8,8,6;5,5,5,5;10,1,1,1" --chi 8 --kernel_size 3,3 --paddings 0,1 --convop
12650 9440,3120 parameters

## Command line on load/save functionalities
python main.py --net conv --cuda 2 --lr 0.001 --lr_decay 0.9 --lr_decay_epochs 50 --l2 1.0e-7 --net conv2 --channels 16,64 --dims "6,8,8,6;5,5,5,5;10,1,1,1" --chi 8 --kernel_size 3,3 --paddings 0,1 --convop --save save/test.pt
python infer.py --load save/test.pt
* This inference command line also works on tx2 *


## Stage 1
### Target on MNIST:

* Compression rate 1/10
* Accuracy decrease 0.3%

### FC2_625 results

* Original 497500 parameters, test_accuracy = 0.9840

  `python main.py --net fc --cuda 0 --D 625 --lr 0.001 --chi 10 --lr_decay 0.99 --lr_decay_epochs 5 --l2 1.0e-7 --bn --log log/mpomlp_fc_625.txt --save save/fc2_625.pt`
  `python infer.py --load save/fc2_625.pt`

* 12270 parameters, 1/40 parameters of the MLP
  test_accuracy = 0.9834, accuracy drop: 0.061%

  `python main.py --net mpomlp --cuda 0 --dims "4,7,7,4;5,5,5,5;1,5,2,1" --lr 0.01 --chi 10 --lr_decay 0.8 --lr_decay_epochs 5 --l2 1.0e-7 --bn --log log/mpomlp_5,5,5,5.txt --save save/mpomlp_5,5,5,5.pt`
  `python infer.py --load save/mpomlp_5,5,5,5.pt`

* 12270 parameters, 1/40 parameters of the MLP test_accuracy = 0.9845, accuracy drop: -0.051%
  `python main.py --net mpomlp --cuda 1 --dims "4,7,7,4;5,5,5,5;1,5,2,1" --lr 0.01 --chi 10 --lr_decay 0.9 --lr_decay_epochs 5 --l2 1.0e-7 --bn --seed 1 --cano 10 --save ./save/MPOMLP_5,5,5,5_cano10.pt --log log/MPOMLP_5,5,5,5_cano10.txt`
  *Inference*
  `python infer.py --load ./save/MPOMLP_5,5,5,5_cano10.pt`
  
### Conv results
* $3\times 3$ convolution, $D=100$, $250326$ parameters test_accuracy 0.9939
`python main.py --net conv2 --cuda 0 --lr 0.001 --lr_decay 0.95 --lr_decay_epochs 30 --l2 1.0e-7 --channels 32,64 --dims "6,8,8,6;5,5,5,5;1,5,2,1" --chi 8 --kernel_size 3,3 --paddings 0,1 --seed 1 --log ./log/mnist_conv_3_32,64_D100.txt --save ./save/mnist_conv_3_32,64_D100.pt`
* $3\times 3$ convolution,$16,16$, $D=256$, $152762$ parameters test_accuracy=
* $3\times 3$ convolution,
* MNIST conv 0.9934 152762
`python main.py --net conv2 --cuda 0 --lr 0.001 --lr_decay 0.95 --lr_decay_epochs 30 --l2 1.0e-7 --channels 16,16 --kernel_size 3,3 --paddings 0,1  --seed 1 --D 256 --seed 1 --valid 200 --save ./save/mnist_conv_16,16_3,3_D256.pl --log ./log/mnist_conv_16,16_3,3_D256.txt`
* MNIST convmpo 0.9909 9572
python main.py --net conv2 --cuda 2 --lr 0.001 --lr_decay 0.95 --lr_decay_epochs 30 --l2 1.0e-7 --channels 16,16 --dims "6,4,4,6;4,4,4,4;1,5,2,1" --chi 10 --kernel_size 3,3 --paddings 0,1 --convmpo --seed 1 --bn --seed 1 --valid 200 --save ./save/mnist_convmpo_16,16_3,3_4,4,4,4_chi10.pl --log ./log/mnist_convmpo_16,16_3,3_4,4,4,4_chi10.txt
* Fashion MNIST 0.9106 152762
python main.py --net conv2 --cuda 3 --lr 0.001 --lr_decay 0.95 --lr_decay_epochs 30 --l2 1.0e-7 --channels 16,16 --kernel_size 3,3 --paddings 0,1  --seed 1 --D 256 --seed 1 --dataset fmnist --valid 200 --save ./save/fmnist_conv_16,16_3,3_D256.pl --log ./log/fmnist_conv_16,16_3,3_D256.txt
* Fashion MNIST convmpo 0.9013 9572
`python main.py --net conv2 --cuda 4 --lr 0.001 --lr_decay 0.95 --lr_decay_epochs 30 --l2 1.0e-7 --channels 16,16 --dims "6,4,4,6;4,4,4,4;1,5,2,1" --chi 10 --kernel_size 3,3 --paddings 0,1 --convmpo --seed 1 --bn --seed 1 --valid 200 --dataset fmnist --save ./save/fmnist_convmpo_16,16_3,3_4,4,4,4_chi10.pl --log ./log/fmnist_convmpo_16,16_3,3_4,4,4,4_chi10.txt`

* Cifar10 conv 0.7104 2477898
`python main.py --net conv2 --cuda 1 --lr 0.001 --lr_decay 0.95 --channels 64,64 --kernel_size 5,5 --paddings 2,0  --seed 1 --D 1024 --seed 1 --valid 200 --dataset cifar10 --size 32 --log ./log/cifar10_conv_64,64_5,5_D1024.txt --save ./save/cifar10_conv_64,64_5,5_D1024.pt`
* Cifar10 convmlp 0.7167 109648
`python main.py --net conv2 --cuda 2 --lr 0.001 --lr_decay 0.95 --channels 64,64 --kernel_size 5,5 --paddings 2,0  --seed 1 --D 625 --seed 1 --valid 200 --dataset cifar10 --size 32 --convmpo --dims "6,8,8,6;8,8,4,4;5,2,1,1" --chi 4 --log ./log/cifar10_convmpo_64,64_5,5_8,8,4,4_chi4.txt --save ./save/cifar10_conv_64,64_5,5_8,8,4,4_chi4.pt`
* Cifar10 convmlp 0.7230 112200
`python main.py --net conv2 --cuda 4 --lr 0.001 --lr_decay 0.95 --channels 64,64 --kernel_size 5,5 --paddings 2,0  --seed 1 --D 625 --seed 1 --valid 200 --dataset cifar10 --size 32 --convmpo --dims "6,8,8,6;8,8,4,4;5,2,1,1" --chi 6 --log ./log/cifar10_convmpo_64,64_5,5_8,8,4,4_chi6.txt --save ./save/cifar10_conv_64,64_5,5_8,8,4,4_chi6.pt`
